calculateGap <-
function(b,wbounds,K=3,S){  
  if(b==1){
	  tmpres = MetaSpaKmeans(x=S ,K=K,wbounds=wbounds)
	  score = lapply(tmpres,function(x) x$score)
	  numGenes = lapply(tmpres,function(x) sum(x$ws!=0))
	  res = list(score=score,numGenes=numGenes)
  	  return(res)
	  } else{
		  set.seed(15213+b)
	      ax = permuteX(S)
		  tmpres = MetaSpaKmeans(x=ax ,K=K,wbounds=wbounds)
		  score = lapply(tmpres,function(x) x$score)
		  res = list(score=score)
	  	  return(res)
	  }   
}
